apiVersion: batch/v1
kind: Job
metadata:
  name: add-app-manager
  labels:
    app: add-app-manager
spec:
  template:
    spec:
      initContainers:
        # Wait for BK_CONFIG_SERVICE to show up
        - name: wait-for-bkconfig
          image: curlimages/curl:latest
          imagePullPolicy: IfNotPresent
          command: ['sh', '-c', 'until [[ "$(curl -s -o /dev/null -w ''%{http_code}'' ${BK_CONFIG_SERVICE_ADDRESS}/health/check)" == "200" ]]; do echo "waiting for service"; sleep 30; done;']
          env:
            - name: BK_CONFIG_SERVICE_ADDRESS
              value: "http://bk-config-service:8008/v1"
      containers:
        - name: add-app-manager
          image: curlimages/curl:latest
          imagePullPolicy: IfNotPresent
          command: ['sh', '-c', 'curl -f "${BK_CONFIG_SERVICE_ADDRESS}/key_pairs/" -X POST -d "{ \"id\": \"1\",  \"privateKey\": \"${PRIVATE_KEY}\",  \"publicKey\": \"${PUBLIC_KEY}\" }" -H "Authentication: ${BK_CONFIG_SERVICE_API_KEY}" ']
          env:
            - name: PRIVATE_KEY
              value: -----BEGIN EC PRIVATE KEY-----\nMHcCAQEEIL+WYjDkIULn/pSZGgQDApAYA3kk5ZYkKUfwD6WVHbkeoAoGCCqGSM49\nAwEHoUQDQgAEtTbVn130qkzHvvM4RGnYTz6Pxq80AoHZKXHK3JL8sqBUbYlC6MoG\nh0MCJ5n/I056quv/FEpdiIyRUgwgsfK7VA==\n-----END EC PRIVATE KEY-----
            - name: PUBLIC_KEY              
              value: -----BEGIN PUBLIC KEY-----\nMFkwEwYHKoZIzj0CAQYIKoZIzj0DAQcDQgAEtTbVn130qkzHvvM4RGnYTz6Pxq80\nAoHZKXHK3JL8sqBUbYlC6MoGh0MCJ5n/I056quv/FEpdiIyRUgwgsfK7VA==\n-----END PUBLIC KEY-----
            - name: BK_CONFIG_SERVICE_ADDRESS
              value: "http://bk-config-service:8008/v1"
            - name: BK_CONFIG_SERVICE_API_KEY
              valueFrom:
                secretKeyRef:
                  name: bk-config-service-api-key
                  key: api-key
      restartPolicy: Never
  backoffLimit: 50
